
#pragma attribute("aid", "F1 22 22 22")

#define MYAPP_CLA               0x22
#define CMD_RAND	        0x10

#define CMD_ADDS		0x20    /* addition short */
#define CMD_ADDM		0x21    /* addition with 160 b mod*/
#define CMD_ADDMM		0x22	/* addition long*/
#define CMD_ADD			0x23    /* addition with put short values*/
#define CMD_ADDL		0x24 
#define CMD_ADDX		0x25
#define CMD_ADDXX		0x26


#define CMD_SUBS		0x30    /* substraction */
#define CMD_SUBM		0x31
#define CMD_SUBMM		0x32
#define CMD_SUB			0x33
#define CMD_SUBL		0x34
#define CMD_SUBX		0x35
#define CMD_SUBXX		0x36

#define CMD_MULS			0x40    /* substraction */
#define CMD_MULM			0x41
#define CMD_MULMM		0x42
#define CMD_MUL			0x43
#define CMD_MULL			0x44
#define CMD_MULX			0x45
#define CMD_MULXX		0x46

#define CMD_EXS			0x50    /* substraction */
#define CMD_EXM			0x51
#define CMD_EXMM		0x52
#define CMD_EX			0x53
#define CMD_EXL			0x54
#define CMD_EXX			0x55
#define CMD_EXXX		0x56


#define CMD_SF		0x60
#define CMD_SM		0x61
#define CMD_SMM		0x62
#define CMD_SL		0x63
#define CMD_SLL		0x64
#define CMD_SX		0x65
#define CMD_SXX		0x66
#define CMD_SET		0x67
#define CMD_SET1		0x68
#define CMD_SET2		0x69

#define CMD_GETA		0x70
#define CMD_GETB		0x71
#define CMD_GETM		0x72
#define CMD_GET		0x73
#define CMD_GET1		0x74
#define ERR_OK                     0x9000
#define ERR_WRONGCLASS             0x6402
#define ERR_BAD_INS                0x6404
#define ERR_CIPHER_DATA_LENGTH_BAD 0x6710
#define ERR_WRONG_LENGTH	   0x6700
#define ERR_SECURITY               0x6405
#define ERR_RSAFIRSTBYTE           0x6720

//definition of lenght in
#define MSGSIZE  255
#define MODLENM   20
#define MODLENMM   64
#define MODLEN   128
#define MODLENL   160
#define MODLENX   192
#define MODLENXX   255
#define EXPLEN   2

#define LEN      8
#define FIX      8

#include <multoscomms.h>
#include <multoscrypto.h>
#include <string.h>
#include <RSA.h>
#include <multosarith.h>
//#include <multoscapi.h>
typedef struct
{
   unsigned char AS[FIX];
} CHAR_S;

typedef struct
{
  unsigned char AM[MODLENM];
} CHAR_M;

typedef struct
{
  unsigned char AMM[MODLENMM];
} CHAR_MM;

typedef struct
{
  unsigned char A[MODLEN];
} CHAR_D;

typedef struct
{
  unsigned char AL[MODLENL];
} CHAR_L;

typedef struct
{
  unsigned char AX[MODLENX];
} CHAR_X;

typedef struct
{
  unsigned char AXX[MODLENXX];
} CHAR_XX;



//public memory
#pragma melpublic
union
{
  CHAR_S    sdata;
  CHAR_M    mdata;
  CHAR_MM    mmdata;
  CHAR_D    data;
CHAR_L    ldata;
CHAR_X    xdata;
CHAR_XX   xxdata;

} apdu_data;
//unsigned char msg[MSGSIZE];




//#pragma melsession
//apdu_data sData;

//fixed data on the card
#pragma melstatic
static unsigned char AS[FIX]= {0x31, 0x31, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11};
static unsigned char BS[FIX] = {0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0xFF};
static unsigned char MS[FIX] = {0x03, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20};
static unsigned char MO[FIX] = {0x02, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05};

//20B 160b
static unsigned char AM[MODLENM]= {0x31, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11};
static unsigned char BM[MODLENM] = {0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0xFF,0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11};
static unsigned char MM[MODLENM] = {0x03, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11};
static unsigned char PM[MODLENM] = {0x02, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11};

//64B 512b
static unsigned char AMM[MODLENMM]= {0x55, 0x55, 0x45, 0x45, 0x45, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x11};

static unsigned char BMM[MODLENMM]= {0x15, 0x75, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x25};

static unsigned char MMM[MODLENMM] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x08};

static unsigned char PMM[MODLENMM] = {0x03, 0x32, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x09};

static unsigned char AL[MODLEN]= {0x55, 0x55, 0x45, 0x45, 0x45, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x45, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x75, 0x15, 0x15};
static unsigned char BL[MODLEN]= {0x15, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x15, 0x15, 0x15};
//128B 1024b
static unsigned char ML[MODLEN] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35};
static unsigned char PL[MODLEN] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35};

//255B 2040b
static unsigned char AXL[MODLENXX]= {0x55, 0x55, 0x45, 0x45, 0x45, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x45, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x75, 0x75, 0x75,
0x55, 0x55, 0x45, 0x45, 0x45, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x45, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x75, 0x75};

static unsigned char BXL[MODLENXX]= {0x75, 0x75, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x15, 0x15, 0x15,
0x75, 0x75, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x15, 0x12};

static unsigned char MXL[MODLENXX] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35,
0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x38};

static unsigned char PXL[MODLENXX] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35,
0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x45};

//192B 1536b
static unsigned char AX[MODLENX]= {0x55, 0x55, 0x45, 0x45, 0x45, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x45, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x75, 0x75, 0x75,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x45, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x75, 0x75, 0x75};

static unsigned char BX[MODLENX]= {0x75, 0x75, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x15, 0x15, 0x15,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x45, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x75, 0x75, 0x75};

static unsigned char MX[MODLENX] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x45, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x75, 0x75, 0x75};

static unsigned char PX[MODLENX] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x45, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x75, 0x75, 0x75};

//160B 1280b
static unsigned char ALL[MODLENL]= {0x55, 0x55, 0x45, 0x45, 0x45, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x45, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x75, 0x75, 0x75,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05};

static unsigned char BLL[MODLENL]= {0x75, 0x75, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x15, 0x15, 0x15,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05};

static unsigned char MLL[MODLENL] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05};

static unsigned char PLL[MODLENL] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05};


void main(void) {

 int i=0;
	int k=1;

 unsigned char num[8];
 
unsigned char AS1[MODLEN];
//unsigned char BS1[MODLEN];

 unsigned char RES[LEN];
 

 if (CLA != MYAPP_CLA)
   ExitSW(ERR_WRONGCLASS);

 switch (INS) {


//ok 20
   case CMD_ADDS:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
       ADDN(FIX, MS, AS, BS);
}
       memcpy(apdu_data.sdata.AS,MS,FIX);
       ExitLa(sizeof(MS));
break;

   //ok 021

      case CMD_ADDM:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     ADDN(MODLENM, MM,AM, BM);
}
    memcpy(apdu_data.mdata.AM,MM,MODLENM);
       ExitLa(MODLENM);
   break;

   //ok 022

      case CMD_ADDMM:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     ADDN(MODLENMM, MMM,AMM, BMM);
}
    memcpy(apdu_data.mmdata.AMM,MMM,MODLENMM);
       ExitLa(MODLENMM);
   break;
   
      //ok 023
      case CMD_ADD:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     ADDN(MODLEN, ML,AL, BL);
}
    memcpy(apdu_data.data.A,ML,MODLEN);
       ExitLa(MODLEN);
   break;



// 24

case CMD_ADDL:
  	if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);	
for(i=0;i<k;i++){
     ADDN(MODLENL, MLL,ALL, BLL);
}
    memcpy(apdu_data.ldata.AL,MLL,MODLENL);
       ExitLa(MODLENL);
   break;


   //ok 025

      case CMD_ADDX:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     ADDN(MODLENX, MX,AX, BX);
}
    memcpy(apdu_data.xdata.AX,MX,MODLENX);
       ExitLa(MODLENX);
   break;


   //ok 026

      case CMD_ADDXX:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     ADDN(MODLENXX, MXL,AXL, BXL);
}
    memcpy(apdu_data.xxdata.AXX,MXL,MODLENXX);
       ExitLa(MODLENXX);
   break;
   
//30
      case CMD_SUBS:
               if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
  	SUBN(FIX,MS,AS,BS);
}
	memcpy(apdu_data.sdata.AS,MS,FIX);
	ExitLa(FIX);
 
        //31
       case CMD_SUBM:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     SUBN(MODLENM, MM,AM,BM);
}
    memcpy(apdu_data.mdata.AM,MM,MODLENM);
       ExitLa(MODLENM);
   break;

        //32
       case CMD_SUBMM:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     SUBN(MODLENMM, MMM,AMM,BMM);
}
    memcpy(apdu_data.mmdata.AMM,MMM,MODLENMM);
       ExitLa(MODLENMM);
   break;

   //33
      case CMD_SUB:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     SUBN(MODLEN,ML,AL,BL);
}
    memcpy(apdu_data.data.A,ML,MODLEN);
       ExitLa(MODLEN);
   break;

   //34
      case CMD_SUBL:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     SUBN(MODLENL,MLL,ALL,BLL);
}
    memcpy(apdu_data.ldata.AL,MLL,MODLENL);
       ExitLa(MODLENL);
   break;

   //ok 035

      case CMD_SUBX:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     SUBN(MODLENX, MX,AX, BX);
}
    memcpy(apdu_data.xdata.AX,MX,MODLENX);
       ExitLa(MODLENX);
   break;


   //ok 036

      case CMD_SUBXX:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
     SUBN(MODLENXX, MXL,AXL, BXL);
}
    memcpy(apdu_data.xxdata.AXX,MXL,MODLENXX);
       ExitLa(MODLENXX);
   break; 

   	//40ok
	case CMD_MULS:
  	if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	memcpy(MS,AS,FIX);
for(i=0;i<k;i++){
	ModularMultiplication(FIX,MS,BS,MO);
}
	memcpy(apdu_data.sdata.AS,MS,FIX);
	ExitLa(FIX);
   	break;

	//41 nasobeni statickych 20 B hodnot, PL je pomocna promenna
	case CMD_MULM:
	if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	memcpy(PM,AM,MODLENM);
for(i=0;i<k;i++){
	ModularMultiplication(MODLENM,PM,BM,MM);
}
	memcpy(apdu_data.mdata.AM,PM,MODLENM);
	ExitLa(MODLENM);
break;

	//42 nasobeni statickych 64 B hodnot, PL je pomocna promenna
	case CMD_MULMM:
	if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	memcpy(PMM,AMM,MODLENMM);
for(i=0;i<k;i++){
	ModularMultiplication(MODLENMM,PMM,BMM,MMM);
}
	memcpy(apdu_data.mmdata.AMM,PMM,MODLENMM);
	ExitLa(MODLENMM);
break;

	//43
	case CMD_MUL:
	if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	memcpy(PL,AL,MODLEN);
for(i=0;i<k;i++){
	ModularMultiplication(MODLEN,PL,BL,ML);
}
	memcpy(apdu_data.data.A,PL,MODLEN);
	ExitLa(MODLEN);
break;


	//44 nasobeni statickych 160 B hodnot, PL je pomocna promenna
	case CMD_MULL:
	if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	memcpy(PLL,ALL,MODLENL);
for(i=0;i<k;i++){
	ModularMultiplication(MODLENL,PLL,BLL,MLL);
}
	memcpy(apdu_data.ldata.AL,PLL,MODLENL);
	ExitLa(MODLENL);
break;

	//45 nasobeni statickych 192 B hodnot, PL je pomocna promenna
	case CMD_MULX:
	if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	memcpy(PX,AX,MODLENX);
for(i=0;i<k;i++){
	ModularMultiplication(MODLENX,PX,BX,MX);
}
	memcpy(apdu_data.xdata.AX,PX,MODLENX);
	ExitLa(MODLENX);
break;

	//46 nasobeni statickych 255 B hodnot, PL je pomocna promenna
	case CMD_MULXX:
	if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	memcpy(PXL,AXL,MODLENXX);
for(i=0;i<k;i++){
	ModularMultiplication(MODLENXX,PXL,BXL,MXL);
}
	memcpy(apdu_data.xxdata.AXX,PXL,MODLENXX);
	ExitLa(MODLENXX);
break;



	//50
	case CMD_EXS:
        if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
//explen,modlen,exp,mod,base,res
for(i=0;i<k;i++){
	ModularExponentiation(FIX,FIX,AS,MO,BS,apdu_data.sdata.AS);
}
	ExitLa(FIX);
break;


	//51 ne
	case CMD_EXM:
        if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
	ModularExponentiation(MODLENM,MODLENM,AM,MM,BM,apdu_data.mdata.AM);
}
	ExitLa(MODLENM);
break;


	//52
	case CMD_EXMM:
        if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	ModularExponentiation(MODLENMM,MODLENMM,AMM,MMM,BMM,apdu_data.mmdata.AMM);
	ExitLa(MODLENMM);
break;

	//53
	case CMD_EX:
        if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
for(i=0;i<k;i++){
	ModularExponentiation(MODLEN,MODLEN,AL,ML,BL,apdu_data.data.A);
}
	ExitLa(MODLEN);
break;

	//54
	case CMD_EXL:
        if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	ModularExponentiation(MODLENL,MODLENL,ALL,MLL,BLL,apdu_data.ldata.AL);
	ExitLa(MODLENL);
break;

	//55
	case CMD_EXX:
        if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	ModularExponentiation(MODLENX,MODLENX,AX,MX,BX,apdu_data.xdata.AX);
	ExitLa(MODLENX);
break;

	//56
	case CMD_EXXX:
        if (!CheckCase(2))
       	ExitSW(ERR_WRONGCLASS);
	ModularExponentiation(MODLENXX,MODLENXX,AXL,MXL,BXL,apdu_data.xxdata.AXX);
	ExitLa(MODLENXX);
break;

//60
	case CMD_SF:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
 		if(P1==0x01) {	
	      memcpy(AS,apdu_data.sdata.AS, FIX); 
 		}
 		else if (P1==0x02)
 		{
	      memcpy(BS,apdu_data.sdata.AS, FIX); 
 		}
	    else 
	    {
	      memcpy(MO,apdu_data.sdata.AS, FIX);
		   }
	Exit();
   break;
   
   //61
	case CMD_SM:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
 		if(P1==0x01) {	
	      memcpy(AM, apdu_data.mdata.AM, MODLENM); 
 		}
 		else if (P1==0x02)
 		{
	      memcpy(BM, apdu_data.mdata.AM, MODLENM); 
 		}
	    else 
	    {
	      memcpy(MM, apdu_data.mdata.AM, MODLENM);
		   }
	Exit();
   break;
   
   //62
	case CMD_SMM:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
 		if(P1==0x01) {	
	      memcpy(AMM, apdu_data.mmdata.AMM, MODLENMM); 
 		}
 		else if (P1==0x02)
 		{
	      memcpy(BMM, apdu_data.mmdata.AMM, MODLENMM); 
 		}
	    else 
	    {
	      memcpy(MMM, apdu_data.mmdata.AMM, MODLENMM);
		   }
	Exit();
   break;
   
   //63
	case CMD_SL:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
 		if(P1==0x01) {	
	      memcpy(AL, apdu_data.data.A, MODLEN); 
 		}
 		else if (P1==0x02)
 		{
 		memcpy(BL, apdu_data.data.A, MODLEN); 	
 		}
	    else 
	    {
	    memcpy(ML, apdu_data.data.A, MODLEN);	
	    }		   
	Exit();
   break;

  //64
	case CMD_SLL:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
 	if(P1==0x01) {	
	      memcpy(ALL, apdu_data.ldata.AL, MODLENL); 
		}
 		else if (P1==0x02)
 		{
	      memcpy(BLL, apdu_data.ldata.AL, MODLENL); 
			}
	    else 
	    {
	      memcpy(MLL, apdu_data.ldata.AL, MODLENL);
		   }
	Exit();
   break;
   
   //65
	case CMD_SX:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
 		if(P1==0x01) {	
	      memcpy(AX, apdu_data.xdata.AX, MODLENX); 
		}
 		else if (P1==0x02)
 		{
	      memcpy(BX, apdu_data.xdata.AX, MODLENX); 
			}
	    else 
	    {
	      memcpy(MX, apdu_data.xdata.AX, MODLENX);
		   }
	Exit();
   break;
   
      //66
	case CMD_SXX:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
		if(P1==0x01) {
	      memcpy(AXL, apdu_data.xxdata.AXX, MODLENXX); 
		}
 		else if (P1==0x02)
 		{
	      memcpy(BXL, apdu_data.xxdata.AXX, MODLENXX); 
			}
	    else 
	    {
	      memcpy(MXL, apdu_data.xxdata.AXX, MODLENXX);
		   }
	Exit();
   break;
   
         //67
	case CMD_SET:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	      memcpy(AS, apdu_data.sdata.AS, FIX); 		   
	Exit();
   break;
   
            //68
	case CMD_SET1:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	      memcpy(BS, apdu_data.sdata.AS, FIX); 		   
	Exit();
   break;
   
   //69
   	case CMD_SET2:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	      memcpy(MO, apdu_data.sdata.AS, FIX); 		   
	Exit();
   break;

	//70
         case CMD_GETA:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
     	if(P1==0x01) {	
     	 memcpy(apdu_data.sdata.AS, AS, FIX);	      
 		}
 		else if (P1==0x02)
 		{
 		 memcpy(apdu_data.mdata.AM, AM, MODLENM); 	
 		}
 			else if (P1==0x03)
 		{
 		 memcpy(apdu_data.mmdata.AMM,AMM,MODLENMM);	
 		}
 			else if (P1==0x04)
 		{
 		 memcpy(apdu_data.data.A, AL, MODLEN); 	
 		}
 			else if (P1==0x05)
 		{
 	 memcpy(apdu_data.ldata.AL,ALL,MODLENL);
 		}
 			else if (P1==0x06)
 		{
 	  memcpy(apdu_data.xdata.AX,AX,MODLENX);
 		}
	    else 
	    {
	      memcpy(apdu_data.xxdata.AXX,AXL,MODLENXX);
	    }	
	
     ExitLa(Le); 
   break;

	//71
         case CMD_GETB:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
	switch(P1) {
		case 01:
	      memcpy(apdu_data.sdata.AS, BS, FIX); 
	          ExitLa(Le); 
		case 02:
	      memcpy(apdu_data.mdata.AM, BM, MODLENM); 
	          ExitLa(Le); 
		case 03:
	      memcpy(apdu_data.mmdata.AMM,BMM,MODLENMM);
	          ExitLa(Le); 
		case 04:
	      memcpy(apdu_data.data.A, BL, MODLEN); 
	          ExitLa(Le); 
		case 05:
	      memcpy(apdu_data.ldata.AL,BLL,MODLENL);
	          ExitLa(Le); 
		case 06:
	      memcpy(apdu_data.xdata.AX,BX,MODLENX);
	          ExitLa(Le); 
		default:
              memcpy(apdu_data.xxdata.AXX,BXL,MODLENXX); 
		   }
     ExitLa(Le); 
   break;

	//72
         case CMD_GETM:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
	switch(P1) {
		case 01:
	      memcpy(apdu_data.sdata.AS, MO, FIX); 
	         ExitLa(Le); 
		case 02:
	      memcpy(apdu_data.mdata.AM, MM, MODLENM); 
	         ExitLa(Le); 
		case 03:
	      memcpy(apdu_data.mmdata.AMM,MMM,MODLENMM);
	         ExitLa(Le); 
		case 04:
	      memcpy(apdu_data.data.A, ML, MODLEN); 
	         ExitLa(Le); 
		case 05:
	      memcpy(apdu_data.ldata.AL,MLL,MODLENL);
	         ExitLa(Le); 
		case 06:
	      memcpy(apdu_data.xdata.AX,MX,MODLENX);
	         ExitLa(Le); 
		default:
              memcpy(apdu_data.xxdata.AXX,MXL,MODLENXX); 
		   }
     ExitLa(Le); 
   break;
   
   //73
case CMD_GET:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
       memcpy(apdu_data.data.A, AL, MODLEN); 
    ExitLa(Le); 
   break;
   
   //74
   case CMD_GET1:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
       memcpy(apdu_data.data.A, AS1, MODLEN); 
    ExitLa(Le); 
   break;
   
      default:
      ExitSW(ERR_BAD_INS);


  
 }


}
