
#pragma attribute("aid", "F2 22 22 22")

#define MYAPP_CLA   0x22

//start protocol C11 C22 C3 C33 a Z1 Z2 Z3 Z4 with generated R and E
#define CMD_RUN		0x20    

//start protocol C11 C22 C3 C33 a Z1 Z2 Z3 Z4 with generated  R and E (optimalized)
#define CMD_RUN3	0x23
 
#define CMD_MUL		0x40

//sets of params
#define CMD_1		0x50  	//RJ
#define CMD_2		0x51	//RJI	
#define CMD_3		0x52	//RD
#define CMD_4		0x53	//RDI
#define CMD_5		0x54	//G2
#define CMD_6		0x55	//W
#define CMD_7		0x56	//Wi
#define CMD_8		0x57	//ej
#define CMD_9		0x58	//eji
#define CMD_10		0x59	//ed	
#define CMD_11		0x61	//edi
#define CMD_12		0x62	//m


//gets paramaters
#define CMD_GETC1		0x72
#define CMD_GETC11		0x73	//ne
#define CMD_GETC3		0x74	//ok
#define CMD_GETC33		0x75	//ok
#define CMD_GETC22		0x76	//ne
#define CMD_GETZ1		0x77	//ok
#define CMD_GETZ11		0x78	//ok
#define CMD_GETZ2		0x79	//ok
	
#define CMD_GETG2		0x80	//ok

#define CMD_GETW		0x81
#define CMD_GETWI		0x82
#define CMD_GETE		0x83
#define CMD_GETRJ		0x84
#define CMD_GETRJI		0x85
#define CMD_GETRD		0x86
#define CMD_GETRDI		0x87

#define CMD_GETZDI		0x88	//ok
#define CMD_GETM		0x89	

#define CMD_GETRJIM		0x90	
#define CMD_GETRDM		0x91	
#define CMD_GETRDIM		0x92	

#define CMD_GETEJ		0x93
#define CMD_GETEJI		0x94
#define CMD_GETE1D		0x95
#define CMD_GETE1DI		0x96

#define ERR_OK                     0x9000
#define ERR_WRONGCLASS             0x6402
#define ERR_BAD_INS                0x6404
#define ERR_WRONG_LENGTH	   	   0x6700


//definition of lenght

//message max len
#define MSGSIZE  255

//160 for w, e
//14 28
#define MODLENM   20 
#define MODLENMM   40 
// we need 380 540 600 760 bits so this is 48 for 384 , 68 544 , 75 600 , 95 760
//v HX 30 44 4B 5F 
#define MODLENJ   48
#define MODLENJI   68
#define MODLEND   75
#define MODLENDI   95
//1024 for c1 c11 c22 c33
#define MODLEN   128 

#define LENG   1

#define FIX      8

#include <multoscomms.h>
#include <multoscrypto.h>
#include <string.h>
#include <multosarith.h>


typedef struct
{ //pro setE
  unsigned char E[MODLENM];
} CHAR_M;

typedef struct
{ //pro setE
  unsigned char EM[MODLENMM];
} CHAR_M2;


typedef struct
{
  unsigned char AJ[MODLENJ];
} CHAR_MM;

typedef struct
{
  unsigned char AJI[MODLENJI];
} CHAR_D;

typedef struct
{
  unsigned char AD[MODLEND];
} CHAR_L;

typedef struct
{
  unsigned char ADI[MODLENDI];
} CHAR_X;

typedef struct
{
  unsigned char A[MODLEN];
} CHAR_XX;



//public memory
#pragma melpublic
union
{
  CHAR_M    edata;
  CHAR_M2    eedata;
  CHAR_MM    jdata;
  CHAR_D    jidata;
CHAR_L    ddata;
CHAR_X    didata;
CHAR_XX   data;

} apdu_data;

//fixed data on the card
#pragma melstatic

//20B 160b e w 
static unsigned char ES[MODLENM]= {0x00, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x00};


//48B  ModularMultiplication(MODLENJ,E1J,W,MJ); 
//	SUBN(MODLENJ,ZJ,RJ,E1J);

static unsigned char E1J[MODLENJ]= {0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb3, 0xe8, 0xbb, 0x57, 0xcc, 0x38, 0xe0, 0x44, 0x5f, 0xd3, 0xd9, 0x90, 0x2a, 0xd7, 0xdf, 0x81, 0xd7, 0x2e, 0xf8};

static unsigned char W[MODLENJ]= {0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x4c ,0xfe ,0xcf ,0x2b ,0x02 ,0x12 ,0xb4 ,0x0e ,0x96 ,0x12 ,0x64 ,0xbc ,0x30 ,0xb7 ,0x89 ,0x0e ,0x06 ,0x61 ,0xd5 ,0x0c};
static unsigned char MJ[MODLENJ] = {0xFF, 0xFF, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x11, 0x05, 0x05, 0xFF, 0xFF};

static unsigned char RJ[MODLENJ] = {0x00, 0x00, 0xe2, 0xbe,0x22, 0xea, 0xe4, 0xe1, 0x24, 0xad, 0x10, 0xef, 
0x8b, 0x4e, 0xde, 0x4c, 0x1a, 0x43, 0xa8, 0x19,0x17, 0xca, 0xfd, 0x89, 0xe7, 0x32, 0x0f, 0xf3, 0xaa, 0xcf, 0x5e, 0x1e, 0x2a, 0x55, 0xa8, 0x3d, 0x28, 0x3b, 0x75, 0x7b, 0x14, 0xc6, 0x09, 0x27, 0x6d, 0xf0, 0x58, 0xed};

static unsigned char ZJ[MODLENJ] = {0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x11, 0x05, 0x00, 0x00, 0x00};

static unsigned char POMJ[MODLENJ] = {0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb3, 0xe8, 0xbb, 0x57, 0xcc, 0x38, 0xe0, 0x44, 0x5f, 0xd3, 0xd9, 0x90, 0x2a, 0xd7, 0xdf, 0x81, 0xd7, 0x2e, 0xf8};

//68	ModularMultiplication(MODLENJI,E1JI,WI,MJI);
//	SUBN(MODLENJI,ZJI,RJI,E1JI);
static unsigned char E1JI[MODLENJI]= 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb3, 0xe8, 0xbb, 0x57, 0xcc, 0x38, 0xe0, 0x44, 0x5f, 0xd3, 0xd9, 0x90, 0x2a, 0xd7, 0xdf, 0x81, 0xd7, 0x2e, 0xf8};


static unsigned char WI[MODLENJI]= 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x3c, 0x12, 0xaa, 0x54, 
0xa4, 0x00, 0x99, 0x20, 0xe7, 0x81, 0xca, 0xf4, 0xe7, 0xfa, 0x41, 0x1b, 0x55, 0xb4, 0x39, 0x08, 0x49, 0x3f, 0x92, 0x29, 0xf2, 0xaa, 0x06, 0x79, 0x1f, 0x8a, 0x70, 0x3c, 0x15, 0xbf, 0x1f, 0xf4, 0x37, 0xc3, 0xce, 0x21};


static unsigned char MJI[MODLENJI] = {0xFF, 0xFF, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x08, 0x05, 0x05, 0xFF, 0xFF};


static unsigned char RJI[MODLENJI] = 
{0x00, 0x00, 0x2e, 0x82, 0x89, 0x52, 0x84, 0xbb, 0x00, 0xc5, 0x5e, 0x74, 0xac, 0x99, 0x3d, 0x8a, 0xd8, 0x77, 0x7b, 0x50, 0x3f, 0x7d, 0x5e, 0xc1, 0xe6, 0xa3, 0x43, 0x4e, 0x70, 0xaa, 0x7e, 0x01, 
0x31, 0x95, 0xd5, 0x67, 0x89, 0xfc, 0xcd, 0x6b, 0xf6, 0x09, 0xf7, 0x86, 0xa1, 0xd5, 0xbc, 0xe3, 0x68, 0x31, 0x6f, 0xe7, 0x82, 0xce, 0x5f, 0x83, 0xd5, 0x63, 0x52, 0x5a, 0x72, 0x4d, 0x77, 0x32, 0x4d, 0xab, 0x04, 0x19};

static unsigned char ZJI[MODLENJI] = 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x09, 0x05, 0x00, 0x00, 0x00};

static unsigned char POMJI[MODLENJI]= 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb3, 0xe8, 0xbb, 0x57, 0xcc, 0x38, 0xe0, 0x44, 0x5f, 0xd3, 0xd9, 0x90, 0x2a, 0xd7, 0xdf, 0x81, 0xd7, 0x2e, 0xf8};


//75 	ModularMultiplication(MODLEND,E1D,RJD,MD);
	//SUBN(MODLEND,ZD,RD,E1D);
static unsigned char E1D[MODLEND]= {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xef,0xb3, 0xe8, 0xbb, 0x57, 0xcc, 0x38, 0xe0, 0x44,0x5f, 0xd3, 0xd9, 0x90, 0x2a, 0xd7, 0xdf, 0x81, 0xd7, 0x2e, 0xf8};

static unsigned char RJD[MODLEND]= {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xbe, 0x22, 
0xea, 0xe4, 0xe1, 0x24, 0xad, 0x10, 0xef, 0x8b, 0x4e, 0xde, 0x4c, 0x1a, 0x43, 0xa8, 0x19,0x17, 0xca, 0xfd, 0x89, 0xe7, 0x32, 0x0f, 0xf3, 0xaa, 0xcf, 0x5e, 0x1e, 0x2a, 0x55, 0xa8, 0x3d, 0x28, 0x3b, 0x75, 0x7b, 0x14, 0xc6, 0x09, 0x27, 0x6d, 0xf0, 0x58, 0xed};

static unsigned char MD[MODLEND] = {0xFF, 0xFF, 0x45, 0x45, 0x45, 0x05, 0x05,0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x08, 0x05, 0x05, 0xFF, 0xFF};


static unsigned char RD[MODLEND] = {0x00, 0x00, 0x00, 0x8e, 0xfe, 0x97, 0x23, 0x01, 0x39, 0x12, 0x4a, 0x0e, 0x11, 0x79, 0x6e, 0x83, 0x9e, 0x2f, 0xb4, 0x64, 0x04, 0xdb, 0xcd, 0xc1, 0xe6, 0xb0, 0xd7, 0x8d, 0xce, 0x9d, 0x18, 0xd5, 0x69, 0x92, 0x19, 0xa3, 0xee, 0x34, 
0xe1, 0xee, 0xec, 0x84, 0xb9, 0x8c, 0xba, 0xcc, 0x38, 0xea, 0x36, 0x45, 0x4e, 0x54, 0xcb, 0x5c, 0xd1, 0x23, 0x9e, 0x20, 0x6b, 0xa3, 0x4e, 0x4e, 0xb7, 0xe2, 0x61, 0x83, 0xc6, 0x1f, 0xe6, 0x02, 0x75, 0x11, 0x69, 0x71, 0x00};

static unsigned char ZD[MODLEND] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x05,0x03, 0x32, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x09, 0x05, 0x05, 0x05, 0x11};

static unsigned char POMD[MODLEND]= {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xef,0xb3, 0xe8, 0xbb, 0x57, 0xcc, 0x38, 0xe0, 0x44,0x5f, 0xd3, 0xd9, 0x90, 0x2a, 0xd7, 0xdf, 0x81, 0xd7, 0x2e, 0xf8};

//95 	ModularMultiplication(MODLENDI,E1DI,RJI,MDI);
	//SUBN(MODLENDI,ZDI,RDI,E1DI);

static unsigned char E1DI[MODLENDI]= {
0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00,0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00,0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00,0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00,0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00,0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00,
 0x00,0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00,0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00,0x00, 0x00, 0x00,
0x00, 0x03, 0xe8, 0xbb, 0x57, 
0xcc, 0x38, 0xe0, 0x44,0x5f, 
0xd3, 0xd9, 0x90, 0x2a, 0xd7, 
0xdf, 0x81, 0xd7, 0x2e, 0xf8};

static unsigned char RJII[MODLENDI]=
{0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00,0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00,0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x2e, 
0x82, 0x89, 
0x52, 0x84, 0xbb, 0x00, 0xc5, 
0x5e, 0x74, 0xac, 0x99, 0x3d, 
0x8a, 0xd8, 0x77, 0x7b, 0x50, 
0x3f, 0x7d, 0x5e, 0xc1, 0xe6, 
0xa3, 0x43, 0x4e, 0x70, 0xaa, 
0x7e, 0x01, 0x31, 0x95, 0xd5, 
0x67, 0x89, 0xfc, 0xcd, 0x6b, 
0xf6, 0x09, 0xf7, 0x86, 0xa1, 
0xd5, 0xbc, 0xe3, 0x68, 0x31, 
0x6f, 0xe7, 0x82, 0xce, 0x5f, 
0x83, 0xd5, 0x63, 0x52, 0x5a, 
0x72, 0x4d, 0x77, 0x32, 0x4d, 0xab, 0x04, 0x19};


static unsigned char MDI[MODLENDI] = {0xFF,0xFF, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11, 0x55, 0x45, 0x45, 0x45, 0x05, 0x05,0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x08, 0x05, 0x05, 0xFF, 0xFF};


static unsigned char RDI[MODLENDI] = {
0x00,0x00,0x08,0x3c,0x2b,0x79,
0xa7,0x8d,0xc3,0xf7,0x81,0x74,
0x69,0xb0,0x84,0x5d,0xf3,0x14,
0x50,0x18,0xdb,0x1b,0x36,0xd2,
0xce,0x2b,0x7e,0x84,0x9b,0xd7,
0xde,0x7b,0x5c,0xbd,0x53,0xb9,
0xbc,0xa9,0xa7,0x80,0x9f,0x98,
0x16,0x12,0x6a,0x8d,0xec,0x9c,
0x33,0x1d,0xa3,0x7a,0x8c,0x6f,
0x3f,0x78,0x0a,0x56,0xa6,0x01,
0x9b,0xb0,0x05,0x36,0xed,0xeb,
0x12,0x29,0xbe,0x20,0x0d,0x56,
0xfb,0xaa,0x3f,0x8d,0x81,0xba,
0x2c,0x45,0x88,0xec,0x01,0x42,
0xf0,0xe9,0x4b,0x9d,0xcd,0xd1,
0xaa,0x7d,0x61,0x1b,0x00};

static unsigned char ZDI[MODLENDI] = {0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00,0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00,0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00,0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00,0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00,0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00,
 0x00,0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00,0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00,0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00,0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00};

static unsigned char POMDI[MODLENDI]= {
0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00,0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00,0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00,0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00,0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00,0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00,
 0x00,0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00,0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00,0x00, 0x00, 0x00,
0x00, 0xb3, 0xe8, 0xbb, 0x57, 
0xcc, 0x38, 0xe0, 0x44,0x5f, 
0xd3, 0xd9, 0x90, 0x2a, 0xd7, 
0xdf, 0x81, 0xd7, 0x2e, 0xf8};

//128B 1024b

static unsigned char M[MODLEN]= {0x37, 0xd6, 0x31, 0x74, 0xa8, 0xa1, 0xd1, 0x6c, 0x80, 0xd5, 0x57, 0x0c, 0xff, 0x69, 0x77, 0xdd, 0x61, 0x52, 0x02, 0x3e, 0xe1, 0x87, 0xbb, 0x9c, 0x5f, 0x32, 0xe0, 0x13, 0x91, 0x8d, 0x8b, 0xdb, 
0x39, 0x7f, 0x37, 0x0a, 0xfe, 0xfb, 0xae, 0xd7, 0x1d, 0x7c, 0xc2, 0xad, 0xaf, 0x6b, 0x35, 0xdf, 0x77, 0x9d, 0x57, 0x4d, 0x30, 0x0e, 0x3b, 0x9e, 0x55, 0x14, 0xe8, 0x22, 0x6b, 0x24, 0x34, 0x78, 
0x11, 0xfc, 0x15, 0x42, 0x1e, 0xbc, 0xf0, 0x52, 0x4c, 0xf4, 0xbc, 0x6c, 0x38, 0x96, 0x2e, 0x4e, 0x83, 0x28, 0xab, 0x88, 0xda, 0xe8, 0x64, 0x02, 0xa2, 0xbf, 0xff, 0xd5, 0xbd, 0xb7, 0x66, 0xaa, 
0x84, 0x47, 0x21, 0x9d, 0x88, 0x4b, 0xb7, 0xae, 0x3a, 0x47, 0x4f, 0xfb, 0xda, 0xb9, 0x3f, 0x31, 0x3d, 0x9b, 0xdc, 0x17, 0xb0, 0x1c, 0xe5, 0x8e, 0x89, 0xa4, 0x33, 0x19, 0x80, 0x49, 0xb0, 0x27};

static unsigned char G1[MODLEN]= 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02};

static unsigned char G2[MODLEN]= 
{0x2d, 0x52, 0x29, 0x52, 0xec, 0x98, 0x99, 0xec, 0x2a, 0x0d, 0xbe, 0xeb, 0x40, 0xbe, 0x3a, 0xd4, 0x05, 0x0e, 0x05, 0x43, 0xcf, 0xd2, 0x9a, 0x20, 0x66, 0xd7, 0xa3, 0x6c, 0x86, 0x70, 0x15, 0xb0, 
0x11, 0x17, 0xaf, 0xbc, 0xed, 0x4b, 0x16, 0x84, 0x67, 0xa2, 0xe0, 0x8b, 0xef, 0x02, 0xc2, 0x4b, 0xf7, 0x30, 0xb7, 0x69, 0x75, 0x1c, 0x76, 0x4b, 0x6b, 0x54, 0x82, 0x93, 0xd6, 0x35, 0x1e, 0xf7, 
0x22, 0x8b, 0xc7, 0x22, 0xbe, 0xf3, 0x9d, 0xb8, 0xaf, 0x3f, 0x52, 0x50, 0xb5, 0xe7, 0xc5, 0xe1, 0x96, 0x71, 0xdb, 0xd2, 0xe9, 0x6f, 0x43, 0x29, 0x0a, 0x36, 0x32, 0xfa, 0xaa, 0xa8, 0x44, 0x6f, 
0x7b, 0xd0, 0x53, 0x0a, 0xbc, 0xec, 0x2e, 0xa4, 0xab, 0x66, 0xa1, 0xd3, 0x66, 0x3a, 0xc7, 0xf7, 0x6f, 0xb8, 0x98, 0x93, 0x0a, 0xcd, 0x96, 0xa4, 0x9b, 0xbb, 0xa7, 0x1f, 0xf3, 0x97, 0x35, 0x8f};


static unsigned char G3[MODLEN]= 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03};

static unsigned char EM[MODLEN]= 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

static unsigned char C1[MODLEN] = 
{0x24, 0x75, 0x29, 0x5c, 0x8c, 0x75, 0x8d, 0xb2, 0x67, 0x0e, 0x25, 0x09, 0x2a, 0xcd, 0x78, 0x69, 0xab, 0x85, 0xae, 0x4c, 0x9e, 0x98, 0x5c, 0x31, 0x27, 0x4f, 0xa6, 0x66, 0x2a, 0x87, 0x01, 0x9e, 
0xa8, 0x1b, 0x9a, 0x5b, 0xc0, 0xa0, 0x77, 0x6a, 0x3d, 0xe0, 0x43, 0xa8, 0x5d, 0xe6, 0xa9, 0xc4, 0x4f, 0x50, 0x67, 0xca, 0xe4, 0x9e, 0xcb, 0x97, 0x8b, 0x9f, 0x2e, 0x98, 0x6e, 0x52, 0x46, 0xa8, 
0x8b, 0xb5, 0x70, 0x55, 0x99, 0xbb, 0x27, 0xda, 0x31, 0x3c, 0x3a, 0xab, 0x37, 0x43, 0xd8, 0x69, 0x01, 0xbb, 0xba, 0xf0, 0xcd, 0xd9, 0x05, 0xa0, 0x9c, 0x69, 0x73, 0x02, 0x57, 0x3d, 0x28, 0xb1, 
0xf5, 0x88, 0x2c, 0x57, 0x5a, 0x88, 0xcb, 0x99, 0xb8, 0xaf, 0xa5, 0x82, 0x0d, 0xcf, 0x7a, 0x63, 0xfb, 0xfc, 0x24, 0xb8, 0x99, 0x65, 0xcd, 0x4a, 0x6a, 0xda, 0x9a, 0xd7, 0x14, 0xed, 0xc4, 0x60};

static unsigned char C11[MODLEN] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35};
static unsigned char C2[MODLEN] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35};
static unsigned char C22[MODLEN] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35};
static unsigned char C3[MODLEN] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35};
static unsigned char C33[MODLEN] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35};
static unsigned char POM1[MODLEN] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35};
static unsigned char POM2[MODLEN] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35};

static unsigned char POM3[MODLEN+20] = {0x03, 0x35, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,0x05, 0x05, 0x05, 0x05, 0x05, 0x35, 0x35, 0x35,
0x31, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,0x11, 0x11, 0x11, 0x11};

static unsigned char WM[MODLEN] = 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 ,0xfe ,0xcf ,0x2b ,0x02 ,0x12 ,0xb4 ,0x0e ,0x96 ,0x12 ,0x64 ,0xbc ,0x30 ,0xb7 ,0x89 ,0x0e ,0x06 ,0x61 ,0xd5 ,0x0c};

static unsigned char WIM[MODLEN] = 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0xaa, 0x54, 0xa4, 0x00, 0x99, 0x20, 
0xe7, 0x81, 0xca, 0xf4, 0xe7, 0xfa, 0x41, 0x1b, 0x55, 0xb4, 0x39, 0x08, 0x49, 0x3f, 0x92, 0x29, 0xf2, 0xaa, 0x06, 0x79, 0x1f, 0x8a, 0x70, 0x3c, 0x15, 0xbf, 0x1f, 0xf4, 0x37, 0xc3, 0xce, 0x21};


static unsigned char RJM[MODLEN] = 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xbe,0x22, 0xea, 0xe4, 0xe1, 0x24, 0xad, 0x10, 0xef, 0x8b, 0x4e, 0xde, 0x4c, 
0x1a, 0x43, 0xa8, 0x19, 0x17, 0xca, 0xfd, 0x89, 0xe7, 0x32, 0x0f, 0xf3, 0xaa, 0xcf, 0x5e, 0x1e, 0x2a, 0x55, 0xa8, 0x3d, 0x28, 0x3b, 0x75, 0x7b, 0x14, 0xc6, 0x09, 0x27, 0x6d, 0xf0, 0x58, 0xed};

static unsigned char RJIM[MODLEN] = 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x89, 0x52, 0x84, 0xbb, 0x00, 0xc5, 0x5e, 0x74, 0xac, 0x99, 0x3d, 0x8a, 0xd8, 0x77, 0x7b, 0x50, 0x3f, 0x7d, 0x5e, 0xc1, 0xe6, 0xa3, 0x43, 0x4e, 0x70, 0xaa, 0x7e, 0x01, 0x31, 0x95, 0xd5, 0x67, 
0x89, 0xfc, 0xcd, 0x6b, 0xf6, 0x09, 0xf7, 0x86, 0xa1, 0xd5, 0xbc, 0xe3, 0x68, 0x31, 0x6f, 0xe7, 0x82, 0xce, 0x5f, 0x83, 0xd5, 0x63, 0x52, 0x5a, 0x72, 0x4d, 0x77, 0x32, 0x4d, 0xab, 0x04, 0x19};

static unsigned char RDM[MODLEN] = {
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x97, 0x23, 0x01, 0x39, 0x12, 0x4a, 
0x0e, 0x11, 0x79, 0x6e, 0x83, 0x9e, 0x2f, 0xb4, 0x64, 0x04, 0xdb, 0xcd, 0xc1, 0xe6, 0xb0, 0xd7, 0x8d, 0xce, 0x9d, 0x18, 0xd5, 0x69, 0x92, 0x19, 0xa3, 0xee, 0x34, 0xe1, 0xee, 0xec, 0x84, 0xb9, 
0x8c, 0xba, 0xcc, 0x38, 0xea, 0x36, 0x45, 0x4e, 0x54, 0xcb, 0x5c, 0xd1, 0x23, 0x9e, 0x20, 0x6b, 0xa3, 0x4e, 0x4e, 0xb7, 0xe2, 0x61, 0x83, 0xc6, 0x1f, 0xe6, 0x02, 0x75, 0x11, 0x69, 0x71, 0xb7};

static unsigned char RDIM[MODLEN] = 
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x3c, 0x2b, 0x79, 0xa7, 0x8d, 0xc3, 0xf7, 0x81, 0x74, 0x69, 0xb0, 0x84, 0x5d, 0xf3, 0x14, 0x50, 0x18, 0xdb, 0x1b, 0x36, 0xd2, 0xce, 0x2b, 0x7e, 0x84, 0x9b, 0xd7, 0xde, 0x7b,
0x5c, 0xbd, 0x53, 0xb9, 0xbc, 0xa9, 0xa7, 0x80, 0x9f, 0x98, 0x16, 0x12, 0x6a, 0x8d, 0xec, 0x9c, 0x33, 0x1d, 0xa3, 0x7a, 0x8c, 0x6f, 0x3f, 0x78, 0x0a, 0x56, 0xa6, 0x01, 0x9b, 0xb0, 0x05, 0x36,
0xed, 0xeb, 0x12, 0x29, 0xbe, 0x20, 0x0d, 0x56, 0xfb, 0xaa, 0x3f, 0x8d, 0x81, 0xba, 0x2c, 0x45, 0x88, 0xec, 0x01, 0x42, 0xf0, 0xe9, 0x4b, 0x9d, 0xcd, 0xd1, 0xaa, 0x7d, 0x61, 0x1b, 0x2e};

//#pragma melpublic
//unsigned char msg[MSGSIZE];

void main(void) {

 int i=0;
	int k =1;

 unsigned char num[8];
unsigned char msg[MODLEN];


 if (CLA != MYAPP_CLA)
   ExitSW(ERR_WRONGCLASS);

 switch (INS) {


//ok 20
   case CMD_RUN:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
/*		
r1 = RandomInteger@82^0, 2^380 - 1<D;
r1i = RandomInteger@82^0, 2^540 - 1<D;
r2 = RandomInteger@82^0, 2^600 - 1<D;
r2i = RandomInteger@82^0, 2^760 - 1<D;
*/
     while(i<48) {
      GetRandomNumber(num);
       memcpy(RJ+i, num, 8);
       i=i+8;
     }
     i=0;

     while(i<68) {
      GetRandomNumber(num);
       memcpy(RJI+i, num, 4);
       i=i+4;
     }
     i=0;

     while(i<75) {
      GetRandomNumber(num);
       memcpy(RD+i, num, 5);
       i=i+5;
     }
     i=0;

     while(i<95) {
      GetRandomNumber(num);
       memcpy(RDI+i, num, 5);
       i=i+5;
     }

// build fixed padding
//memset(Sign.FixedPad, 0x55, PADSZ);
memset(RJM, 0x00, 80);
memcpy(RJM+80,RJ,48);

memset(RJD, 0x00, 27);
memcpy(RJD+27,RJ,48);

memset(RJIM, 0x00, 60);
memcpy(RJIM+60,RJI,68);

memset(RJII, 0x00, 27);
memcpy(RJII+27,RJI,68);

memcpy(RDM+53,RD,75);

memcpy(RDIM+33,RDI,95);


//c1 = A;
//ModularExponentiation(MODLEN,MODLEN,WM,M,G1,C1);
//ModularExponentiation(MODLEN,MODLEN,WIM,M,G2,POM2);
//ModularMultiplication(MODLEN,C1,POM2,M);

//c11 = Mod@PowerMod@g1, r1, nD * PowerMod@g2, r1i, nD, nD;
	 //explen,modlen,exp,mod,base,res
ModularExponentiation(MODLEN,MODLEN,RJM,M,G1,C11);
ModularExponentiation(MODLEN,MODLEN,RJIM,M,G2,POM2);

ModularMultiplication(MODLEN,C11,POM2,M);

//c2 = c11;
 memcpy(C2,C11,MODLEN);

//c3 = PowerMod@g3, r1, nD;
ModularExponentiation(MODLEN,MODLEN,RJM,M,G3,C3);

//c22 = Mod@PowerMod@g1, r2, nD * PowerMod@g2, r2i, nD, nD;
ModularExponentiation(MODLEN,MODLEN,RDM,M,G1,C22);
ModularExponentiation(MODLEN,MODLEN,RDIM,M,G2,POM2);
ModularMultiplication(MODLEN,C22,POM2,M);

//c33 = PowerMod@g3, r2, nD;
ModularExponentiation(MODLEN,MODLEN,RDM,M,G3,C33);

//e1 = SHA(c1+c2+c3+c22+c33);
SHA1(MODLEN,ES,C1);

memcpy(POM3,C2,128);
memcpy(POM3+128,ES,20);
SHA1(MODLEN+20,ES,POM3);

memcpy(POM3,C22,128);
memcpy(POM3+128,ES,20);
SHA1(MODLEN+20,ES,POM3);

memcpy(POM3,C3,128);
memcpy(POM3+128,ES,20);
SHA1(MODLEN+20,ES,POM3);

memcpy(POM3,C33,128);
memcpy(POM3+128,ES,20);
SHA1(MODLEN+20,ES,POM3);

memset(E1J, 0x00,28);
memcpy(E1J+28,ES,20);

memset(E1JI, 0x00,48);
memcpy(E1JI+48,ES,20);

memset(E1D, 0x00,55);
memcpy(E1D+55,ES,20);

memset(E1DI, 0x00,75);
memcpy(E1DI+75,ES,20);

//z1 = r1 - e1 * w;
memcpy(POMJ,E1J,MODLENJ);
ModularMultiplication(MODLENJ,POMJ,W,MJ);
	SUBN(MODLENJ,ZJ,RJ,POMJ);

//z1i = r1i - e1 * wi;
memcpy(POMJI,E1JI,MODLENJI);
	ModularMultiplication(MODLENJI,POMJI,WI,MJI);
	SUBN(MODLENJI,ZJI,RJI,POMJI);

//z2 = r2 - e1 * r1;
memcpy(POMD,E1D,MODLEND);
	ModularMultiplication(MODLEND,POMD,RJD,MD);
	SUBN(MODLEND,ZD,RD,POMD);

//z2i = r2i - e1 * r1i;
memcpy(POMDI,E1DI,MODLENDI);
	ModularMultiplication(MODLENDI,POMDI,RJII,MDI);
	SUBN(MODLENDI,ZDI,RDI,POMDI);

	 	 //e is returned to user
     //  memcpy(apdu_data.data.A,RJIM,MODLEN);
         memcpy(apdu_data.jdata.AJ,E1J,MODLENJ);
       ExitLa(MODLENJ);
break;



//--------------------------------------------------------------------
  //ok 23
   case CMD_RUN3:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
     
     /*		
r1 = RandomInteger@82^0, 2^380 - 1<D;
r1i = RandomInteger@82^0, 2^540 - 1<D;
r2 = RandomInteger@82^0, 2^600 - 1<D;
r2i = RandomInteger@82^0, 2^760 - 1<D;
*/
      while(i<48) {
      GetRandomNumber(num);
       memcpy(RJ+i, num, 8);
       i=i+8;
     }
     i=0;

     while(i<68) {
      GetRandomNumber(num);
       memcpy(RJI+i, num, 4);
       i=i+4;
     }
     i=0;

     while(i<75) {
      GetRandomNumber(num);
       memcpy(RD+i, num, 5);
       i=i+5;
     }
     i=0;

     while(i<95) {
      GetRandomNumber(num);
       memcpy(RDI+i, num, 5);
       i=i+5;
     }

// set all Rs

memcpy(RJM+80,RJ,48);
memcpy(RJD+27,RJ,48);

memcpy(RJIM+60,RJI,68);
memcpy(RJII+27,RJI,68);

memcpy(RDM+53,RD,75);

memcpy(RDIM+33,RDI,95);
 

//c11 = Mod@PowerMod@g1, r1, nD * PowerMod@g2, r1i, nD, nD;
	 //explen,modlen,exp,mod,base,res
ModularExponentiation(MODLEN,MODLEN,RJM,M,G1,C11);
ModularExponentiation(MODLEN,MODLEN,RJIM,M,G2,POM2);
ModularMultiplication(MODLEN,C11,POM2,M);

//c3 = PowerMod@g3, r1, nD;
ModularExponentiation(MODLEN,MODLEN,RJM,M,G3,C3);

//c22 = Mod@PowerMod@g1, r2, nD * PowerMod@g2, r2i, nD, nD;
ModularExponentiation(MODLEN,MODLEN,RDM,M,G1,C22);
ModularExponentiation(MODLEN,MODLEN,RDIM,M,G2,POM2);
ModularMultiplication(MODLEN,C22,POM2,M);

//c33 = PowerMod@g3, r2, nD;
ModularExponentiation(MODLEN,MODLEN,RDM,M,G3,C33);

//e1 from chain of hash SHA over c1 c11 c22 c3 c33
SHA1(MODLEN,ES,C1);

memcpy(POM3,C11,128);
memcpy(POM3+128,ES,20);
SHA1(MODLEN+20,ES,POM3);

memcpy(POM3,C22,128);
memcpy(POM3+128,ES,20);
SHA1(MODLEN+20,ES,POM3);

memcpy(POM3,C3,128);
memcpy(POM3+128,ES,20);
SHA1(MODLEN+20,ES,POM3);

memcpy(POM3,C33,128);
memcpy(POM3+128,ES,20);
SHA1(MODLEN+20,ES,POM3);

memset(E1J, 0x00,28);
memcpy(E1J+28,ES,20);

memset(E1JI, 0x00,48);
memcpy(E1JI+48,ES,20);

memset(E1D, 0x00,55);
memcpy(E1D+55,ES,20);

memset(E1DI, 0x00,75);
memcpy(E1DI+75,ES,20);


//z1 = r1 - e1 * w;
ModularMultiplication(MODLENJ,E1J,W,MJ);
	SUBN(MODLENJ,ZJ,RJ,E1J);

//z1i = r1i - e1 * wi;
	ModularMultiplication(MODLENJI,E1JI,WI,MJI);
	SUBN(MODLENJI,ZJI,RJI,E1JI);

//z2 = r2 - e1 * r1;
	ModularMultiplication(MODLEND,E1D,RJD,MD);
	SUBN(MODLEND,ZD,RD,E1D);

//z2i = r2i - e1 * r1i;
	ModularMultiplication(MODLENDI,E1DI,RJII,MDI);
	SUBN(MODLENDI,ZDI,RDI,E1DI);

	 //e is returned to user
        memcpy(apdu_data.edata.E,ES,20);
       ExitLa(20);
break;

// Sets --------------------------------------------------------------------------------

	//50
	case CMD_1:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(RJ, apdu_data.jdata.AJ, MODLENJ); 
		
	Exit();
   break;

	//51
	case CMD_2:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(RJI, apdu_data.jidata.AJI, MODLENJI);
	Exit();
   break;
	//52
	case CMD_3:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(RD, apdu_data.ddata.AD, MODLEND);
	Exit();
   break;
	//53
	case CMD_4:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(RDI, apdu_data.didata.ADI, MODLENDI); 
	Exit();
   break;
   	//54
	case CMD_5:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(G2, apdu_data.data.A, MODLEN);
	Exit();
   break;
	//55
	case CMD_6:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(W+28, apdu_data.edata.E, 20);
	memcpy(WM+108, apdu_data.edata.E, 20);
	Exit();
   break;
   
		//56
	case CMD_7:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(WI+28, apdu_data.eedata.EM, 40);
	memcpy(WIM+88, apdu_data.eedata.EM, 40);
	Exit();
   break;
   
   		//57
	case CMD_8:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(E1J, apdu_data.jdata.AJ, MODLENJ); 
	Exit();
   break;
   
   		//58
	case CMD_9:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(E1JI, apdu_data.jidata.AJI, MODLENJI);
	Exit();
   break;
   
   		//59
	case CMD_10:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(E1D, apdu_data.ddata.AD, MODLEND); 
	Exit();
   break;
   
   		//61
	case CMD_11:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(E1DI, apdu_data.didata.ADI, MODLENDI); 
	Exit();
   break;
   
      		//62
	case CMD_12:
 	if (!CheckCase(3))
       ExitSW(ERR_WRONGCLASS);
	memcpy(M, apdu_data.data.A, MODLEN); 
	Exit();
   break;


//Gets ------------------------------------------------------------------------------------------
 
 //72
         case CMD_GETC1:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, C1, MODLEN);		   
     ExitLa(Le); 
   break;

//73
         case CMD_GETC11:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, C11, MODLEN);		   
     ExitLa(Le); 
   break;
   
   case CMD_GETC3:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, C3, MODLEN);		   
     ExitLa(Le); 
   break;
   
   case CMD_GETC33:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, C33, MODLEN);		   
     ExitLa(Le); 
   break;
   
   case CMD_GETC22:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, C22, MODLEN);		   
     ExitLa(Le); 
   break;

   case CMD_GETZ1:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.jdata.AJ, ZJ, MODLENJ);		   
     ExitLa(Le); 
   break;
   
      case CMD_GETZ11:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.jidata.AJI, ZJI, MODLENJI);		   
     ExitLa(Le); 
   break;
   
      case CMD_GETZ2:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.ddata.AD, ZD, MODLEND);		   
     ExitLa(Le); 
   break;
   
         case CMD_GETG2:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, G2, MODLEN);		   
     ExitLa(Le); 
   break;
   
         case CMD_GETZDI:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.didata.ADI, ZDI, MODLENDI);		   
     ExitLa(Le); 
   break;
   
      case CMD_GETW:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.jdata.AJ, W, MODLENJ);		   
     ExitLa(Le); 
   break;
   
      case CMD_GETWI:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.jidata.AJI, WI, MODLENJI);		   
     ExitLa(Le); 
   break;
   
     case CMD_GETE:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.edata.E,ES,MODLENM);   		   
     ExitLa(Le); 
   break;
   
      case CMD_GETRJ:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.jdata.AJ, RJ, MODLENJ);		   
     ExitLa(Le); 
   break;
   
      case CMD_GETRJI:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.jidata.AJI, RJI, MODLENJI);		   
     ExitLa(Le); 
   break;
   
      case CMD_GETRD:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.ddata.AD, RD, MODLEND);		   
     ExitLa(Le); 
   break;
   
      case CMD_GETRDI:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.didata.ADI, RDI, MODLENDI);		   
     ExitLa(Le); 
   break;
   
         case CMD_GETM:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, M, MODLEN);		   
     ExitLa(Le); 
   break;
   
         case CMD_GETRJIM:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, RJIM, MODLEN);		   
     ExitLa(Le); 
   break;
   
         case CMD_GETRDM:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, RDM, MODLEN);		   
     ExitLa(Le); 
   break;
   
         case CMD_GETRDIM:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.data.A, RDIM, MODLEN);		   
     ExitLa(Le); 
   break;
   
          case CMD_GETEJ:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.jdata.AJ, E1J, MODLENJ);		   
     ExitLa(Le); 
   break;
   
       case CMD_GETEJI:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.jidata.AJI, E1JI, MODLENJI);		   
     ExitLa(Le); 
   break;
          case CMD_GETE1D:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.ddata.AD, E1D, MODLEND);		   
     ExitLa(Le); 
   break;
   
       case CMD_GETE1DI:
     if (!CheckCase(2))
       ExitSW(ERR_WRONGCLASS);
		 memcpy(apdu_data.didata.ADI, E1DI, MODLENDI);		   
     ExitLa(Le); 
   break;   
      default:
      ExitSW(ERR_BAD_INS);


  
 }


}
